﻿' -----------------------------------------------------------------------------------------
'
' WiiExplorer                                                       Ulrich Müller  10.10.10
'                                                                   Aspire  VB 2008 Express
' Steuerung eines Robo Explorers über einen Wii Remote
'
' -----------------------------------------------------------------------------------------

Option Explicit On
Option Strict Off
Imports FishFace40
Imports WiimoteLib

Public Class WiiExplorer

  Dim ft As New FishFace()
  Dim wii As New Wiimote()
  Dim gelbOn As Boolean = False

    Private Sub Action()
    Do
      If wii.WiimoteState.ButtonState.Up Then
        ft.SetMotor(Out.M1, Dir.Left)
        ft.SetMotor(Out.M2, Dir.Left)
      ElseIf wii.WiimoteState.ButtonState.Down Then
        ft.SetMotor(Out.M1, Dir.Right)
        ft.SetMotor(Out.M2, Dir.Right)
      ElseIf wii.WiimoteState.ButtonState.Left Then
        ft.SetMotor(Out.M1, Dir.Left)
        ft.SetMotor(Out.M2, Dir.Right, Speed.Half)
      ElseIf wii.WiimoteState.ButtonState.Right Then
        ft.SetMotor(Out.M1, Dir.Right)
        ft.SetMotor(Out.M2, Dir.Left, Speed.Half)
      ElseIf wii.WiimoteState.ButtonState.Plus Then
        tmrGelb.Enabled = True
      ElseIf wii.WiimoteState.ButtonState.Minus Then
        tmrGelb.Enabled = False
        ft.SetMotor(Out.O4, Dir.Off)
      Else
        ft.SetMotor(Out.M1, Dir.Off)
        ft.SetMotor(Out.M2, Dir.Off)
      End If
      ft.Pause(333)
    Loop Until ft.Finish()
    ft.SetMotor(Out.O4, Dir.Off)
    End Sub

#Region "--- ProgramControl ---"
  Private Sub cmdAction_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) _
    Handles cmdAction.Click
    ' --- Open erste ROBO Interface an USB oder Intelligent Interface an COM ---
    '     während des Ablaufs von Action gesperrt
    Try
      If cboPortName.SelectedIndex = 0 Then
        ft.OpenInterface(IFTypen.ftROBO_first_USB, 0)
      Else
        ft.OpenInterface(IFTypen.ftIntelligent_IF, cboPortName.SelectedIndex, 5)
      End If
      wii.Connect()
      wii.SetLEDs(False, True, True, False)

      cmdAction.Enabled = False
      cmdEnde.Text = "&HALT"
      lblStatus.Text = "--- Bei der Arbeit ---"

      Action()          ' --- Nutz-Routine für die Anwendung

      ft.ClearMotors()
    Catch ex As FishFaceException
      MsgBox(ex.Message)
    Finally
      ft.CloseInterface()
      wii.Disconnect()
      tmrGelb.Enabled = False
      cmdAction.Enabled = True
      cmdEnde.Text = "&ENDE"
      lblStatus.Text = "--- Auf ein Neues ---"
      cmdEnde.Focus()
    End Try

  End Sub

    Private Sub cmdEnde_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdEnde.Click
        ' --- Programmende nur, wenn Action nicht läuft ---
        If cmdEnde.Text = "&HALT" Then ft.NotHalt = True Else Me.Close()
    End Sub

    Private Sub frmLoad(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' --- Default erstes ROBO Interface an USB ---
        cboPortName.SelectedIndex = 0
    End Sub

    Private Sub frmClosing(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
        ' --- Wenn Action läuft, wird ein Programmabbruch über (x) unterbunden ---
        If cmdEnde.Text = "&HALT" Then e.Cancel = True
    End Sub

#End Region

  Private Sub tmrGelb_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tmrGelb.Tick
    If gelbOn Then
      ft.SetMotor(Out.O4, Dir.On)
    Else
      ft.SetMotor(Out.O4, Dir.Off)
    End If
    gelbOn = Not gelbOn
  End Sub
End Class
